part of query;

class Update implements Statement {
  String _tableName;

  final Map<String, dynamic> _values = {};

  final And _where = new And();

  Update() {
    _info = new QueryUpdateInfo(this);
  }

  Update into(String tableName) {
    if (_tableName != null) {
      throw new Exception("Name already assigend!");
    }
    _tableName = tableName;
    return this;
  }

  Update set<ValType>(Field<ValType> field, ValType value) {
    setValue(field.name, value);
    return this;
  }

  Update setMany(List<SetColumn> columns) {
    columns.forEach((SetColumn column) {
      setValue(column._column, column._value);
    });
    return this;
  }

  Update setValue<ValType>(String column, ValType value) {
    _values[column] = value;
    return this;
  }

  Update setValues(Map<String, dynamic> values) {
    _values.addAll(values);
    return this;
  }

  Update where(Expression exp) {
    _where.and(exp);
    return this;
  }

  Update eq<T>(String column, T val) => where(q.eq<T>(column, val));

  Update ne<T>(String column, T val) => where(q.ne<T>(column, val));

  Update gt<T>(String column, T val) => where(q.gt<T>(column, val));

  Update gtEq<T>(String column, T val) => where(q.gtEq<T>(column, val));

  Update ltEq<T>(String column, T val) => where(q.ltEq<T>(column, val));

  Update lt<T>(String column, T val) => where(q.lt<T>(column, val));

  Update like(String column, String val) => where(q.like(column, val));

  Update between<T>(String column, T low, T high) =>
      where(q.between<T>(column, low, high));

  QueryUpdateInfo _info;

  QueryUpdateInfo get info => _info;
}

class QueryUpdateInfo {
  final Update _inner;

  QueryUpdateInfo(this._inner)
      : values = new UnmodifiableMapView<String, dynamic>(_inner._values);

  String get tableName => _inner._tableName;

  final UnmodifiableMapView<String, dynamic> values;

  //TODO immutable
  And get where => _inner._where;
}
